
#                 STANDARD INTRO                \
 CLIENT: XiRCON                                 \
 SCRIPT: TCL                                    \
 AUTHOR: KANO (KEITH LEA)                       \
 SCRIPT NAME: kano.tcl                          \
 PLATFORM: WINDOWS                              \
 STATUS: RELEASE 1                              \
#                                               \
  NOTE: Please every1 put this in your scripts so
# We can know what it is we have when we get it.

if [file exists ksave.tcl] {source ksave.tcl}

#procs

proc uhost nick {
    global do_who
    if [info exists who([string tolower $nick])] {return $who([string tolower $nick])} {return $nick!*@* ; /who $nick ; incr do_who ; complete}
}

proc kanovers {} {
    return "kano.tcl v1"
}

proc chanlist chan {
    set nix ""
    foreach i [nicks $chan] {
	lappend nix [string trim $i @+]
    }
    return $nix
}

proc rand {start end} {
    set x [expr [clock clicks] % [expr $end - $start]]
    set x [expr $x + $start]
}

proc oplist chan {
    set nix ""
    foreach i [nicks $chan @*] {
	lappend nix [string trim $i @]
    }
    return $nix
}

proc vlist chan {
    set nix ""
    foreach i [nicks $chan +*] {
	lappend nix [string trim $i +]
    }
    return $nix
}

proc ison {nick chan} {
    set nick [string tolower $nick]
    foreach i [string tolower [nicks $chan]] {
	if {$i == $nick} {return 1}
    }
    return 0
}

proc isop {nick chan} {
    set nick [string tolower $nick]
    foreach i [string tolower [nicks $chan @*]] {
	if {$nick == [string trimleft $i @]} {return 1}
    }
    return 0
}

proc isvoice {nick chan} {
    set nick [string tolower $nick]
    foreach i [string tolower [nicks $chan +*]] {
	if {$i == [string trim $i +]} {return 1}
    }
    return 0
}

proc arg {} {
    return [join [args]]
}

proc longip { ip } {
    global tcl_precision
    set tcl_precision 17
    set result 0
    regexp {([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)} $ip s b3 b2 b1 b0
    if { ![string compare $ip $s] } {
        set total 0
        set total [expr $total + double($b3) * pow(256,3)]
        set total [expr $total + double($b2) * pow(256,2)]
        set total [expr $total + double($b1) * pow(256,1)]
        set total [expr $total + double($b0) * pow(256,0)]
        set result [format "%10.0f" $total]
    }
    return $result
}

proc stricmp { s1 s2 } {
    return [string compare [string tolower $s1] [string tolower $s2]]
}

proc ctime unixtime {return [clock format $unixtime]}

proc unixtime {} {return [clock seconds]}

#vars

if [info exists umode] {/quote mode [my_nick] $umode}
if ![info exists isplay] {set isplay -1}
if ![info exists do_who] {set do_who 0}
if ![info exists idle] {set idle 0}
if ![info exists lastmin] {set lastmin [string range [lindex [ctime [unixtime]] 3] 0 4]}
if ![info exists lastniq] {set lastniq ""}
if ![info exists xdcc] {set xdcc ""}
if ![info exists sound(on)] {set sound(on) 0}
if ![info exists sound(dir)] {set sound(dir) "."}
if ![info exists ajoin] {set ajoin ""}
if ![info exists ll(time)] {set ll(time) 90}
if ![info exists ll(on)] {set ll(on) 0}
if ![info exists links] {set links ""}
if ![info exists lastlinks] {set lastlinks [expr [unixtime] - 90]}
if ![info exists oldlinks] {set oldlinks ""}
if ![info exists splits] {set splits ""}
if ![info exists isaway] {set isaway 0}
if ![info exists away] {set away 0}

#hooks

on timer {
    incr idle
    if {([expr [unixtime] - $lastlinks] >= $ll(time)) && ($ll(on))} {
	/quote LINKS
	set lastlinks [unixtime]
    }
    if {$isplay != "-1"} {
	if {[llength $readz] < $isplay} {set isplay -1 ; echo "stopped playing" [lindex $playch 0] [lindex $playch 1]} {
	    if {[lindex $readz $isplay] != ""} {
		/msg [lindex $playch 1] [lindex $readz $isplay]
	    }
	    incr isplay
	}
    }
    if {$lastmin != [string range [lindex [ctime [unixtime]] 3] 0 4]} {
	if {$idle > 600 && !$isaway} {
	    /away Auto-away after 10 minutes
	    set isaway 1
	}
	set lastmin [string range [lindex [ctime [unixtime]] 3] 0 4]
    }
}

on connect {
    if [info exists ajoin] {/join $ajoin}
    if [info exists umode] {/quote mode [my_nick] $umode}
}

on notify {
    if {[window_type] != "status"} {
	echo "[color highlight][nick] [user]@[host] is on irc"
    }
    echo "[color highlight][nick] [user]@[host] is on irc" status
}
on denotify {
    if {[window_type] != "status"} {
	echo "[color highlight][nick] has left irc"
    }
    echo "[color highlight][nick] has left irc" status
}

on join {
    if {[nick] == [my_nick]} {/quote WHO [lindex [arg] 0]} else {
	/quote WHO [nick]
    }
    incr do_who
}

on nick {
    set who([string tolower [arg]]) [uhost [nick]]
    unset who([string tolower [nick]])
    if {[nick] == [my_nick]} {
	foreach i [channels] {
	    echo "[color change]*** Your nickname is now [color nick][arg]" channel $i
	}
	echo "[color change]*** Your nickname is now [color nick][arg]" status
    }
}

on quit {
    echo "[color quit]*** Quit: [color nick][nick][color quit] ([arg])" status
    if [info exists who([string tolower [nick]])] {unset who([string tolower [nick]])}
}

on 436 {
    echo "[color error]*** Nickname collision -- changing nickname"
    /nick [string range [my_nick] 0 5]-[string range [unixtime] [expr [string length [unixtime]] - 2] end]
}

on 364 {
    lappend links [lindex [arg] 1]
}

on 365 {
    foreach i $links {
	if {[lsearch $oldlinks $i] == "-1"} {
	    lappend splits $i
	}
    }
    foreach i $oldlinks {
	if {[lsearch $splits $i] != "-1"} {
	    set splits [lreplace $splits [lsearch $splits $i] [lsearch $splits $i]]
	}
    }
    set oldlinks $links
    set links ""
}

on 331 {
    echo "No topic is set on 4[lindex [arg] 0]" status
    complete
}

on 332 {
    echo "Topic for [lindex [arg] 1] is: 12[string trimleft [lrange [arg] 2 end] :]" status
    complete
}

on 352 {
    set arg [lrange [arg] 1 end]
    set who([string tolower [lindex $arg 4]]) "[lindex [arg] 2]@[lindex [arg] 3]"
    if {$do_who != "0"} {complete}
}

on 315 {
    if {$do_who != "0"} {complete ; incr do_who -1}
}

set vers {
    "Official mIRC hater"
    "Kano Wins"
    "FATALITY"
    "You weak, pathetic fool.."
    "It's official, you suck"
    "Muhahahhaha..."
    "Don't make me laugh"
    "...eat your heart out"
    "I'm An Official Black Dragon Gangsta"
    "FINISH HIM!"
    "FINISH HER!"
    "j00 will die, mortal"
    "Toasty!"
}

on ctcp {
    set arg [arg]
    set cmd [string tolower [lindex $arg 1]]
    if {$cmd == "version"} {
	/quote NOTICE [nick] :VERSION XiRCON ($tcl_platform(os)) # [kanovers] by k-no - [lindex $vers [rand 0 [llength $vers]]]
	complete
    } elseif {$cmd == "sound" && [string index $arg 0] == "#"} {
	if {$sound(on) && [lindex $arg 0] == [channel]} {mmstop wave ; mmplay $sound(dir)\\[lindex [arg] 1]}
	echo "[color highlight]([lindex $arg 2]) [color nick]* [nick][color public] [lrange [arg] 3 end]" channel [lindex $arg 0]
	complete
    } elseif {$cmd == "xdcc"} {
	set c2 [string tolower [lindex $arg 2]]
	if {$c2 == "list"} {
	    /xdcc notc [nick]
	} elseif {$c2 == "send"} {
	    if {[string trim [lindex $arg 3] 1234567890#] != ""} {
		/quote NOTICE [nick] :/ctcp [my_nick] xdcc send #N
	    } else {
		set y [lindex $xdcc [expr [string trim [lindex $arg 3] #] - 1]]
		if {$y == ""} {
		    /quote NOTICE [nick] :No such pack.
		} else {
		    /dcc send [nick] [lindex $y 0]
		    /quote NOTICE [nick] :Sending you [lindex $y 1] ([lindex $y 0]).
		    echo "[color ctcp]*** Sending [nick]![user]@[host] [lindex $y 0]" status
		    set x ""
		    foreach i $xdcc {
			if {[lindex $i 0] == [lindex $y 0]} {
			    lappend g [lindex $i 0]
			    lappend g [lindex $i 1]
			    lappend g [expr [lindex $i 2] + 1]
			    lappend x $g
			} else {
			    lappend x $i
			}
		    }
		    set xdcc $x
		    /ksave q
		}
	    }
	} else {
	    /quote NOTICE [nick] :/ctcp [my_nick] XDCC <SEND | LIST>
	}
    }
}

on privmsg {
    set arg [args]
    set say [lindex $arg 1]
    if [string match *[string tolower [my_nick]]* [string tolower $say]] {
	echo "[color highlight][nick]? $say" channel [lindex $arg 0]
	complete
	if {[lsearch $lastniq [nick]] != "-1"} {
	    set lastniq [lreplace $lastniq [lsearch $lastniq [nick]] [lsearch $lastniq [nick]]]
	}
	set lastniq "$lastniq [nick]"
    }
}

on mode+b {
    set arg [lindex [arg] 1]
    set chan [lindex [arg] 0]
    if [string match $arg [my_nick]![my_user]@[my_host]] {
        /mode $chan -b $arg
    }
}

on mode+b {
    set arg [lindex [arg] 1]
    set chan [lindex [arg] 0]
    foreach i [string tolower [nicks $chan]] {
	set i [string trim $i @+]
        if [string match $arg $i![uhost $i]] {/kick $chan $i You're banned! # [kanovers] #}
    }
}

#hotkeys

hotkey f2 {
    input set_text "[string trim [lrange $lastniq end end] " "]: "
    input set_sel_start [string length "[lrange $lastniq end end]: "]
    if {$lastniq == ""} {complete}
    set lastniq "[lrange $lastniq end end] [lrange $lastniq 0 [expr [llength $lastniq] - 2]]"
}

hotkey f3 {
    set text [input get_text]
    set nick ""
    set niq [string trimright $text :]
    foreach i [nicks [channel] @$niq*] {
	set nick [string trimleft $i "@+"]
    }
    foreach i [nicks [channel] $niq*] {
	set nick [string trimleft $i "@+"]
    }
    if {$nick != ""} {
	input set_text "$nick: "
	input set_sel_start [string length "$nick: "]
    }
}

alias help {
    set help() {
Alias help: (ex. /help amsg)
AWAY  BACK  INV   TCL   J     P
OP    DEOP  PING  AMSG  AME   MME
GME   MSAY  SCR   K     KB    MOD
DNS   BAN   LL    UMODE SREQ  SOUND
KSAVE AJOIN NJOIN COLOR AUSER RUSER
USERS CUSER WI    WW    WII   XDCC
IGNR  T     WALL  PLAY
----------------------------------
Other help: (ex. /help 03 - NOT /help 3)
01 SELF-BAN PROT
02 KICK-WHEN-BANNED
03 NICK COMP
04 AUTO-AWAY
05 /WHO INFO
06 SOUND REQUESTS
07 CTCP VERSION
08 LINK-LOOKER
09 AUTO-REPLY
10 SAVE FILE
}
    set help(t) "shortcut for /topic (ex. /t blah blah blah)"
    set help(wall) "does one of those nifty '-NickName- \[WallOp:\] text' messages that goes to all the ops, if you're an op"
    set help(play) "like 12mIRC[color default]'s /play command, kinda (ex. /play README.TXT)"
    set help(ignr) "ignores a hostmask (ex. /ignr *!*khaled@*.uk private)"
    set help(xdcc) "this has its own help, type '/xdcc'"
    set help(wi) "same as /whois"
    set help(ww) "same as /whowas"
    set help(wii) "same as /whois <nick> <nick> -- you can see idle time and logon time"
    set help(auser) "adds a nickname's user@host to the userlist (ex. /auser kano)"
    set help(ruser) "removes a nickname from the userlist (ex. /ruser khaled)"
    set help(users) "displays all users to you"
    set help(cuser) "counts all of the users"
    set help(color) "says a string of text, each time a different color"
    set help(njoin) "removes a channel from the auto-join list (ex. /njoin #mirc)"
    set help(ajoin) "sets your auto-join channels (ex. /ajoin #xircon #windows #mk3)"
    set help(ll) "try it; it's help on the link looker"
    set help(sreq) "type /sreq and see (help on sound requests)"
    set help(sound) "sends a sound request to the channel and does an action (ex. /sound hello.wav Hello there!)"
    set help(umode) "sets your usermode (ex. /umode +k-wis)"
    set help(away) "will set you away, and send a message to all channels saying you're away"
    set help(back) "will set you back, and send a message to all the channels you're on saying so"
    set help(inv) "invites someone to your current channel"
    set help(tcl) "will evaluate a tcl command"
    set help(j) "will join a channel"
    set help(p) "will part a channel, or your current channel if none is specified"
    set help(op) "will op as many people you say"
    set help(deop) "will deop as many people you say"
    set help(ping) "will ping someone, or your current channel if none is specified"
    set help(amsg) "will send your message to all channels you're in"
    set help(ame) "will do a /me in all chans you're in"
    set help(mme) "same as /ame"
    set help(gme) "same as /ame"
    set help(msay) "same as /amsg"
    set help(scr) "tells you which scripts you have loaded"
    set help(k) "kicks someone from your current channel"
    set help(kb) "kicks and bans someone from your current channel, using the /who info"
    set help(mod) "sets a mode in your current channel"
    set help(dns) "gives you the inverse of a hostname"
    set help(ban) "bans someone from your current channel using the /who info"
    set help(sreq) "type /sreq and see"
    set help(ksave) "saves current settings to a file (ex. sound dir, link-looking interval, etc)"
    set help(01) "when someone bans you, this will try to unban you"
    set help(02) "when someone's banned, this will try to kick them"
    set help(03) "when you type something like 'ka: hello!' and 'kano' is on the channel, you will say 'kano: hello!'"
    set help(04) "after 10 minutes of you not sending a msg to anyone or talking in a chan, it will set you away"
    set help(05) {when you load this script, it will perform a silent /who on all the channels you're on, and save all the info it recieves
when you join a channel, it will perform a /who on the channel
when someone joins a channel, it will perform a /who on them}
    set help(06) "type /sreq for help on this"
    set help(07) "the ctcp version reply is 'XiRCON # [kanovers] - Official mIRC hater'"
    set help(08) "the link-looker is automatically off.. try /ll to see other options"
    set help(09) "if someone says your nick, press F2 and the input box will begin with 'theirnick: ' -- to scroll through the nicks, continue pressing F2"
    set help(10) "use /ksave to save some important variables to the file 'ksave.tcl'
when [kanovers] is loaded, it automatically loads ksave.tcl, so you have your old variables set again
this saves sound vars (whether u accept sounds, and the dir), link-look vars (whether it's on, and time interval), your current usermode, auto-join channels, and your xdcc list
this will save after those variables have been set"
    set arg [string tolower [arg]]
    if ![info exists help($arg)] {echo "no help available on '$arg'"} {
	echo $help($arg)
    }
    complete
}

alias PRIVMSG {
    set idle 0
    if {[lindex [args] 0] == [channel] && [string match *: [lindex [args] 1]]} {
	set nick ""
	set niq [lindex [split [lindex [args] 1] :] 0]
	foreach i [nicks [channel] @$niq*] {
	    set nick [string trimleft $i "@+"]
	}
	foreach i [nicks [channel] $niq*] {
	    set nick [string trimleft $i "@+"]
	}
	if {$nick != ""} {say "$nick: [lrange [join [args]] 2 end]" ; complete}
    }
}

alias xdcc {
    set arg [arg]
    set cmd [string tolower [lindex $arg 0]]
    set arg [lrange $arg 1 end]
    if {$cmd == "add"} {
	if {[llength $arg] < 2} {
	    echo "usage: /xdcc add <file> <description>"
	} else {
	    if ![file exists [lindex $arg 0]] {
		echo "file '[lindex $arg 0]' doesn't exist!"
		echo "try using slashes instead of backslashes, if you used them"
	    } else {
		set b ""
		lappend b [lindex $arg 0]
		lappend b [lrange $arg 1 end]
		lappend b 0
		lappend xdcc $b
		echo "added [lindex $arg 0]: [lrange $arg 1 end]"
		/ksave q
	    }
	}
    } elseif {$cmd == "rem"} {
	set xdcc2 ""
	set count 0
	foreach i $xdcc {
	    if {[lindex $i 0] != $arg} {
		lappend xdcc2 $i
	    } else {incr count}
	}
	set xdcc $xdcc2
	echo "removed $count entries"
	/ksave q
    } elseif {$cmd == "list"} {
	set count 1
	foreach i $xdcc {
	    echo [format "#$count %-12s (%4sK) \[%2s gets\] : [lindex $i 1]" [lrange [split [lrange [split [lindex $i 0] \\] end end] /] end end] [expr [file size [lindex $i 0]] / 1024] [lindex $i 2]]
	    incr count
	}
    } elseif {$cmd == "offer"} {
	set count 1
	say "[llength $xdcc] packs offered"
	foreach i $xdcc {
	    say [format "#$count %-12s (%4sK) \[%2s gets\] : [lindex $i 1]" [lrange [split [lrange [split [lindex $i 0] \\] end end] /] end end] [expr [file size [lindex $i 0]] / 1024] [lindex $i 2]]
	    incr count
	}
	say "/ctcp [my_nick] XDCC SEND #N to get pack #N"
    } elseif {$cmd == "notc"} {
	set count 1
	/quote NOTICE $arg :[llength $xdcc] packs offered
	foreach i $xdcc {
	    /quote NOTICE $arg :[format "#$count %-12s (%4sK) \[%2s gets\] : [lindex $i 1]" [lrange [split [lrange [split [lindex $i 0] \\] end end] /] end end] [expr [file size [lindex $i 0]] / 1024] [lindex $i 2]]
	    incr count
	}
	/quote NOTICE $arg :/ctcp [my_nick] XDCC SEND #N to get pack #N
    } else {
	echo "OFFER LIST  ADD   REM"
	echo "NOTC"
	echo "---------------------"
	echo "choose one (ex. /xdcc offer)"
	echo "/xdcc NOTC does a /xdcc offer, but to only one nick"
	echo "the rest are obvious"
    }
    complete
}

alias ignr {
    if {![string match *!*@* [lindex [arg] 0]] || [string match "* *" [lindex [arg] 0]]} {
	echo "invalid hostmask (ex. *!*keith@*.oswego.edu)"
    } else {
	set g [string tolower [lindex [arg] 1]]
	set x [add_user [arg]]
	if {$g == ""} {
	    set way private
	} elseif {$g != "private" && $g != "public" && $g != "all"} {
	    echo "usage: /ignore <mask> \[none | all | private | public\]"
	    return
	    complete
	} else {
	    set way $g
	}
	set_user $x ignore $way
	set_user $x notes "/ignored at [clock format [clock seconds] -format "%m/%d/%y %H:%M:%S"]"
	echo "ignored [lindex [arg] 0] ($way)"
    }
    complete
}

proc maskhost host1 {
    if [string match *!* $host1] {
	return [maskhost [lrange [split $host1 !] 1 2]]
    } else {
	set x [split $host1 @]
    }
    set user [string trimleft [lindex $x 0] ~]
    set host [lindex $x 1]
    set y [split $host .]
    if {[llength $y] == "2"} {set y $host} else {
	if {[string trim [string range $host end end] 1234567890] == ""} {
	    set y [join [lrange $y 0 2] .].*
	} else {
	    set y *.[join [lrange $y 1 end] .]
	}
    }
    return *!*$user@$y
}

alias color {
    say "[rand 1 16],[rand 10 100][arg]"
    complete
}

alias wi {/whois [arg] ; complete}

alias ww {/whowas [arg] ; complete}

alias wii {/whois [arg] [arg] ; complete}

alias ajoin {
    if {[arg] == ""} {echo "auto-join: $ajoin" ; complete}
    if {$ajoin == ""} {set ajoin [join [arg] ,]} else {
	set arg [join [arg] ,]
	append arg ,$arg
    }
    echo "auto-join: $ajoin"
    /ksave q
    complete
}

alias njoin {
    if {[arg] == ""} {echo "auto-join: $ajoin" ; complete}
    set j ""
    foreach i [split $ajoin ,] {
	if {[string tolower $i] != [string tolower [arg]]} {append j ,$i}
    }
    set ajoin [string trim $j ,]
    echo "auto-join: $ajoin"
    /ksave q
    complete
}

alias chat {/dcc chat [arg] ; complete}

alias ksave {
    set x [open ksave.tcl w]
    puts $x "set sound(on) \{$sound(on)\}"
    puts $x "set sound(dir) \{$sound(dir)\}"
    puts $x "set ll(on) \{$ll(on)\}"
    puts $x "set ll(time) \{$ll(time)\}"
    puts $x "set umode \{[mode]\}"
    puts $x "set ajoin \{$ajoin\}"
    puts $x "set xdcc \{$xdcc\}"
    close $x
    if {[arg] != "q"} {echo "saved variables"}
    complete
}

alias auser {
    add_user [maskhost [uhost [arg]]]
    echo "added user"
    complete
}

alias ruser {
    set x [find_user [arg]]
    if {$x == "-1"} {
	echo "can't find a user matching that"
    } else {
	delete_user $x
	echo "deleted user"
    }
    complete
}

alias users {
    for {set y 0} {$y < [expr [user_count] + 1]} {incr y} {
	lappend files [get_user $y mask]
    }
    set count 1
    set cnt2 1
    foreach i $files {
	if {[string length [lindex [split $i /] [expr [llength [split $i /]] - 1]]] > 24} {set f ...} else {set f ""}
	lappend five($cnt2) [string range [lindex [split $i /] [expr [llength [split $i /]] - 1]] 0 21]$f
	if {[expr $count % 3] == "0"} {
	    incr cnt2
	}
	incr count
    }
    foreach j [lsort [array names five]] {
	set j $five($j)
	echo [format "%-25s  %-25s  %-25s" [lindex $j 0] [lindex $j 1] [lindex $j 2] [lindex $j 3] [lindex $j 4]]
    }
    echo "total users: [llength $files]"
    complete
}

alias cuser {
    echo "[expr [user_count] + 1] users"
    complete
}

alias sound {
    mmstop wave
    mmplay [lindex [arg] 0]
    /quote PRIVMSG [channel] :SOUND [arg]
    echo "[color highlight][lindex [arg] 0][color nick] * [my_nick][color public] [lrange [arg] 1 end]"
    complete
}

alias sreq {
    set x [string tolower [lindex [arg] 0]]
    if {$x == "" || ($x == "help" && [llength [arg]] == 1)} {
	echo {
ON    OFF   DIR   LIST
----------------------
Choose (ex. /sreq off)
Or get help 
(ex. /sreq help dir)
        }
    } elseif {$x == "on"} {
	echo "turned sounds on"
	set sound(on) 1
	/ksave q
    } elseif {$x == "off"} {
	echo "turned sounds off"
	set sound(on) 0
	/ksave q
    } elseif {$x == "dir"} {
	if {[lrange [arg] 1 end] == ""} {
	    echo "sound dir is $sound(dir)"
	    complete
	}
	if ![file isdirectory [lrange [arg] 1 end]] {
	    echo "no such directory (note: you can't use dirs like 'c:\xircon' or 'c:\windows\irc' -- they have to be local (like '..\..\windows\irc' etc.))"
	} else {
	    set sound(dir) [string trim [lrange [arg] 1 end] /]
	    echo "sound dir is now $sound(dir)"
	}
	/ksave q
    } elseif {$x == "list"} {
	set files [lsort [glob -nocomplain $sound(dir)\\\\*.wav]]
	set count 1
	set cnt2 1
	foreach i $files {
	    lappend five($cnt2) [string range [lindex [split $i /] [expr [llength [split $i /]] - 1]] 0 11]
	    if {[expr $count % 5] == "0"} {
		incr cnt2
	    }
	    incr count
	}
	foreach j [lsort [array names five]] {
	    set j $five($j)
	    echo [format "%-12s %-12s %-12s %-12s %-12s" [lindex $j 0] [lindex $j 1] [lindex $j 2] [lindex $j 3] [lindex $j 4]]
	}
	echo "total wavs: [llength $files]"
    } else {
	echo "invalid command!"
    }
    complete
}

alias umode {
    /mode [my_nick] [arg]
    complete
}

alias ll {
    set x [string tolower [lindex [arg] 0]]
    if {$x == ""} {
	echo {
TIME  ON    OFF   SPLT
----------------------
Choose:   (ex. /ll on)
}
    } elseif {$x == "time"} {
	if {[lrange [arg] 1 end] == ""} {
	    echo "Link-look interval: $ll(time)"
	} else {
	    if {[string trim [lrange [arg] 1 end] 1234567890] != ""} {
		echo "invalid time!!"
	    } else {
		set ll(time) [lrange [arg] 1 end]
		echo "set interval to [lrange [arg] 1 end]"
	    }
	    /ksave q
	}
    } elseif {$x == "on"} {
	set ll(on) 1
	echo "turned llooking on"
	/ksave q
    } elseif {$x == "off"} {
	set ll(on) 0
	echo "turned link-looking off"
	/ksave q
    } elseif {$x == "splt"} {
	echo "Splits: $splits"
    } else {
	echo "invalid /ll command"
    }
    complete
}

alias quit {
    /quote QUIT :[arg] # [kanovers] #
}

alias aw {/away [arg] ; complete}
alias away {
    /ame is away!@#$! # [arg] # away @ [ctime [unixtime]]
    set away [unixtime]
    /quote AWAY :[arg]
    set isaway 1
    complete
}

alias back {
    set aw [expr [unixtime] - $away]
    /ame is back!@#$! # away for [expr $aw / 60] minutes [expr $aw % 60] seconds
    unset away
    set isaway 0
    /quote AWAY
    complete
}

alias inv {
    foreach i [arg] {
	/invite $i [channel]
    }
    complete
}

alias tcl {
    echo "Tcl: [eval [arg]]"
    complete
}

alias t {
    /topic [channel] [arg]
    complete
}

alias play {
    if ![file exists [arg]] {
	echo "no such file '[arg]'"
    } elseif {$isplay != "-1"} {
	echo "already playing a file!"
    } else {
	set x [open [arg]]
	set readz ""
	while {![eof $x]} {
	    lappend readz [gets $x]
	}
	close $x
	set isplay 0
	set playch "[window_type] [window_name]"
	echo "playing [arg] at 1 line/sec"
    }
    complete
}

alias wall {
    if ![isop [my_nick] [channel]] {echo "you're not an op" ; complete} {
	foreach i [oplist [channel]] {
	    if {$i != [my_nick]} {
		/quote NOTICE $i :\[WallOp:\] [arg]
	    }
	}
	echo "[color nick]-[my_nick]- [color notice]\[WallOp:\] [arg]"
    }
    complete
}

alias j {
    set arg [arg]
    if {[string index $arg 0] != "#"} {set arg #$arg}
    /join $arg
    complete
}

alias p {
    set arg [arg]
    set chan [channel]
    if {$chan == ""} {echo "[color errors]* Stupid, you're not on a channel." ; complete}
    if {$arg == ""} {/part $chan ; complete}
    if {[string index $arg 0] != "#"} {set arg #$arg}
    /part [arg]
    complete
}

alias op {
    set arg [arg]
    set mode ""
    foreach i $arg {
        lappend mode $i
        if {[llength $mode] == "3"} {/mode [channel] +ooo $mode ; set mode ""}
    } 
    if {$mode != ""} {/mode [channel] +ooo $mode}
    complete
}

alias deop {
    set arg [arg]
    set mode ""
    foreach i $arg {
        lappend mode $i
        if {[llength $mode] == "3"} {/mode [channel] -ooo $mode ; set mode ""}
    }
    if {$mode != ""} {/mode [channel] -ooo $mode}
    complete
}

alias ping {
    set arg [arg]
    if {$arg == ""} {set arg [channel]}
    /ctcp $arg ping
    complete
}

alias amsg {
    foreach c [channels] {
        /msg $c [arg]
    }
    complete
}

alias ame {
    foreach c [channels] {
        /ctcp $c ACTION [arg]
        echo "[color nick]* [my_nick][color public] [arg]" channel $c
    }
    complete
}

alias mme {/ame [arg] ; complete}

alias gme {/ame [arg] ; complete}

alias msay {/amsg [arg] ; complete}

alias scr {
    echo "Loaded scripts:"
    set i 0
    foreach s [scripts] {
        echo "\[[incr i]\] $s"
    }
    complete
}

alias k {
    set arg [arg]
    /kick [channel] $arg # [kanovers] #
    complete
}

alias kb {
    /ban [arg]
    /k [arg] banned
    complete
}

alias mod {
    set arg [arg]
    /mode [channel] [arg]
    complete
}

alias ban {
    if [info exists who([string tolower [lindex [arg] 0]])] {
	/mode [channel] +b [maskhost [lindex $who([string tolower [lindex [arg] 0]]) 1]@[lindex $who([string tolower [lindex [arg] 0]]) 2]]
    } else {
	/quote WHO [lindex [arg] 0]
	incr do_who
	echo "[color error]*** No user@host for [lindex [arg] 0] - try again in a few seconds"
    }
    complete
}

foreach i [channels] {
    /quote WHO $i
    incr do_who
}

/quote WHO [my_nick]
incr do_who

#---------------------------------------------------------------------------
# Domain Name Resolution
#---------------------------------------------------------------------------
set dns_nicks ""

alias dns {
    set host [arg]
    if { [string match *.* $host] } {
        lookup $host
        echo "*** Attempting to resolve $host"
    } else {
        lappend dns_nicks [string tolower $host]
        whois $host
        echo "*** Retrieving information for $host"
    }
    complete
}

on lookup {
    set request [lindex [args] 0]
    set result  [lindex [args] 1]
    if { [string length $result] } {
        echo "*** Resolved $request to $result"
    } else {
        echo "[color error]*** ERROR: Could not resolve $request"
    }
}

on whois {
    set nick [string tolower [nick]]
    set i [lsearch $dns_nicks $nick]
    while { $i > -1 } {
        lookup [host]
        echo "*** Attempting to resolve [host]"
        set dns_nicks [lreplace $dns_nicks $i $i]
        set i [lsearch $dns_nicks $nick]
    }
}

on 401 {
    set nick [lindex [args] 1]
    set i [lsearch $dns_nicks $nick]
    while { $i > -1 } {
        set dns_nicks [lreplace $dns_nicks $i $i]
        set i [lsearch $dns_nicks $nick]
    }
}

#popup menus

menu status "*&Join #XiRCON" { /join #XiRCON }
menu status ""
menu status "&MOTD"          { /motd }
menu status ""
menu status "&Away"          { /away [prompt Away "Away message:" "no reason =)" }
menu status "&Back"          { /back }


menu channel "*&Properties" { show_props channel [arg] }


menu query "*&Whois"         { /whois [arg] }
menu query ""
menu query "&CTCP->&Ping"    { /ctcp [arg] ping }
menu query "&CTCP->&Version" { /ctcp [arg] version }
menu query "&CTCP->&Time"    { /ctcp [arg] time }
menu query "&CTCP->&???"     { /ctcp [arg] [prompt "CTCP Message" "CTCP [arg] what?"] }
menu query ""
menu query "&Finger"         { /finger [arg] }


menu chat "*&Whois"         { /whois [arg] }
menu chat ""
menu chat "&CTCP->&Ping"    { /ctcp [arg] ping }
menu chat "&CTCP->&Version" { /ctcp [arg] version }
menu chat "&CTCP->&Time"    { /ctcp [arg] time }
menu chat "&CTCP->&???"     { /ctcp [arg] [prompt "CTCP Message" "CTCP [arg] what?"] }
menu chat ""
menu chat "&Finger"         { /finger [arg] }


menu users "&Whois"   { /whois [arg] }
menu users "*&Query"  { /query [arg] }
menu users ""
menu users "&Op"      { /op [arg] }
menu users "&Deop"    { /deop [arg] }
menu users ""
menu users "&Kick!"   { /kick [arg] }
menu users "&Ban!"    { /ban [arg] }
menu users "&Kickban!" { /kb [arg] }
menu users ""
menu users "&CTCP->&Ping"    { /ctcp [arg] ping }
menu users "&CTCP->&Version" { /ctcp [arg] version }
menu users "&CTCP->&Time"    { /ctcp [arg] time }
menu users "&CTCP->&???"     { /ctcp [arg] [prompt "CTCP Message" "CTCP [arg] what?"] }
menu users ""
menu users "&Slap!" { /me slaps [arg] around a bit with a big fat [kanovers] }

echo "[color highlight]*** You have loaded [kanovers] ***" status
echo "[color highlight]***    Type /help for help   ***" status
echo "(No big motd to waste your time)" status
echo "--------------------------------" status
